﻿/*  ....Commentary....

REQUIRED ACTIVE FILE:

  SampleFile_UNSTRUCTURED.fm

DESCRIPTION:    

This is a script that iterates over all paragraphs
in the main flow and reports their first 50 characters
and the paragraph format in use. Note that it will
not look inside of tables.

The sample file listed is a good candidate on which
to run the script, but any file with a main flow will 
probably work fine.

Like all scripts, if some particular aspect is
described in detail in some "preceeding"
script in the batch, it will be described only
briefly here.

*/

//Let's declare these here, which will
//be used more later.
var actions = 0;
var condition = null;

var prop;

//Time to start the main operation. Get the active document first.
var doc = app.ActiveDoc;
if(doc.ObjectValid() == true) 
    condition = doc.GetNamedObject (Constants.FO_CondFmt, "Comment");

//If we have an active document, let's
//do the requested task.
if(doc.ObjectValid() == true && condition != null)
{
    var condArray = new Array();
    condArray.push(condition);


    var pgf = doc.MainFlowInDoc.FirstTextFrameInFlow.FirstPgf;
    
    //Run this loop until we run out of valid paragraphs
    while(pgf.ObjectValid() == true)
    {
        var tr = new TextRange();
        
        tr.beg.obj = tr.end.obj = pgf;
        tr.beg.offset = 0;
        tr.end.offset = 0;//Constants.FV_OBJ_END_OFFSET;

        var tempProp = doc.GetTextPropVal(tr.beg, Constants.FP_InCond);
        
        if(actions == 0 && tempProp.propVal.osval.length == 0)
        {
            alert("got it");
            prop.propVal.isval[0] = condition.id;

            prop.propVal.osval[0] = condition;

             actions = 1;
            
       }
    
        pgf = pgf.NextPgfInFlow;
    }
        //prop = new PropVal(); 
        //prop.propVal = new TypedVal();
        
       // val = new TypedVal;
        
        //prop.propIdent.num = Constants.FP_InCond;
        //alert(prop.propVal.osval.length);// = condArray; 
        //prop.propVal.osval = condArray.slice(0);
   
      //prop.propVal.osval.push(condition);
        


    
    //We'll start by getting the first paragraph in the main flow,
    //then iterate over each paragraph, checking the name of the
    //last format applied, then reapplying the updated format as applicable.
    //To get the first paragraph, notice how we drill down through object
    //properties and "ownership." The doc owns the main flow, the flow owns
    //its first text frame, and a text frame owns its first paragraph.
    var pgf = doc.MainFlowInDoc.FirstTextFrameInFlow.FirstPgf;
    
    //Run this loop until we run out of valid paragraphs
    while(pgf.ObjectValid() == true)
    {
        var tr = new TextRange();
        
        tr.beg.obj = tr.end.obj = pgf;
        tr.beg.offset = 1;
        tr.end.offset = 6;//Constants.FV_OBJ_END_OFFSET;
        
        if(actions == 10)
        {
        var prop = doc.GetTextPropVal(tr.beg, Constants.FP_InCond)
        //prop = new PropVal(); 
        //prop.propVal = new TypedVal();
        
       // val = new TypedVal;
        
        //prop.propIdent.num = Constants.FP_InCond;
        //alert(prop.propVal.osval.length);// = condArray; 
        //prop.propVal.osval = condArray.slice(0);
        prop.propVal.osval.push(condition);
        
        actions++;
        }
       
       
        doc.SetTextPropVal(tr, prop);
        
        pgf = pgf.NextPgfInFlow;
        
       //if(!pgf.NextPgfInFlow.ObjectValid()) break;
        
     
        //Text ranges can be tough to get your mind around. Don't expect
        //to understand them immediately.  There is no document window,
        //mouse, or keyboard available when you need to do something
        //from a script. So, this is the methodology that scripts use. Allow
        //some time and experimentation to get the hang of it.


        
        //Now, let's isolate the text into a single variable for convenience. It's
        //stored in the text items, but we'll do this to make the rest of the
        //script more intuitive. One thing we'll need to do is make
        //sure that there actually is any text. We can test the length of the
        //text items structure to know for sure.
        
        //So, if there was any text retrieved...

    }
}

//Else, if we did not find an active document, let's
//warn.
else
{
    alert("No active document found or the active document "
      + "does not have the required condition in its template. Cannot continue.");
}

alert("Script complete!");
